<?php

namespace WebsiteBundle\Controller\Site;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use WebsiteBundle\Entity\PsychEducationPanel;

class FAQController extends Controller
{

  public function indexAction(Request $request) {

    $templateData = [
      'headerTitle' => 'VEELGESTELDE VRAGEN',
      'psychoFaqItems' => $this->getPsychoFaqItems()
    ];

    $response = $this->render('@Website/FAQ/faq.html.twig', $templateData);

    $response->setMaxAge(300);
    $response->setSharedMaxAge(300);

    return $response;
  }

  private function getPsychoFaqItems() {
    $user = $this->getUser();

    //If there is no logged in user don't show any psycho education FAQ items
    if (empty($user)) {
      return [];
    }

    $psychoRepo = $this->get('doctrine.orm.entity_manager')->getRepository(PsychEducationPanel::class);
    return $psychoRepo->getPsychoFaqItems($user);
  }

}
