<?php

namespace WebsiteBundle\Entity;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use WebsiteBundle\Security\Roles;

/**
 * @ORM\Entity(repositoryClass="WebsiteBundle\Repository\TestRepository")
 * @ORM\HasLifecycleCallbacks
 */
class Test extends BaseEntity {

  //Type constants
  const TYPE_PASAT = 'PASAT';
  const TYPE_APASAT = 'APASAT';
  const TYPE_CONTROL = 'CONTROL';

  /**
   * @ORM\Column(type="string")
   * @var string
   * @Assert\NotBlank
   */
  private $name;

  /**
   * @ORM\Column(type="string")
   * @var string
   * @Assert\Choice(choices={"PASAT", "APASAT", "CONTROL"})
   */
  private $type;

  /**
   * @ORM\Column(type="text")
   * @var string
   */
  private $tutorialText;
  public function getName()
  {
    return $this->name;
  }

  public function setName($name)
  {
    $this->name = $name;

    return $this;
  }

  public function getType()
  {
    return $this->type;
  }

  public function setType($type)
  {
    $this->type = $type;

    return $this;
  }

  public function getTutorialText()
  {
    return $this->tutorialText;
  }

  public function setTutorialText($tutorialText)
  {
    $this->tutorialText = $tutorialText;

    return $this;
  }

  public function getRoleRequiredForView() {
    return Roles::ROLE_ADMIN;
  }

}
