<?php

namespace Bazookas\AdminBundle\Controller\Exception;

use \Symfony\Bundle\TwigBundle\Controller\ExceptionController as DefaultExceptionController;
use Symfony\Component\HttpFoundation\Request;

class ExceptionController extends DefaultExceptionController
{
  private $requiredLocales;

  public function __construct(\Twig_Environment $twig, $debug, $requiredLocales) {
    $this->requiredLocales = $requiredLocales;
    parent::__construct($twig, $debug);
  }

  protected function findTemplate(Request $request, $format, $code, $showException)
  {
    if (!$showException && preg_match('/\/('.$this->requiredLocales.')\/admin\/.*/', $request->getRequestUri())) {
      $template = sprintf('BazookasAdminBundle:Exception:%s%s.%s.twig', 'error', $code, 'html');
      if ($this->templateExists($template)) {
        return $template;
      }
    }

    return parent::findTemplate($request, $format, $code, $showException);
  }

}
