<?php

namespace Bazookas\AdminBundle\Dashboard\Elements;

use Bazookas\AdminBundle\Dashboard\Base\BaseDashboardElement;

/**
 * @deprecated
 *
 * Class AlertElement
 * @package Bazookas\AdminBundle\Dashboard\Elements
 */
class AlertElement extends BaseDashboardElement {

  //type constants
  const TYPE_INFO = 'info';
  const TYPE_DANGER = 'danger';
  const TYPE_SUCCESS = 'success';
  const TYPE_PRIMARY = 'primary';

  public $message;

  public $type;

  public $isDismissible;

  public function __construct($children = [], $options = []) {
    parent::__construct($children, $options);
    $this->message = $this->options['message'];
    $this->type = $this->options['type'];
    $this->isDismissible = $this->options['isDismissible'];
  }

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:Dashboard\Elements:alertElement.html.twig',
      'class' => '',
      'message' => '',
      'type' => self::TYPE_INFO,
      'isDismissible' => true
    ]);
  }

  public function getMessage()
  {
    return $this->message;
  }

  public function setMessage($message)
  {
    $this->message = $message;

    return $this;
  }

  public function getType()
  {
    return $this->type;
  }

  public function setType($type)
  {
    $this->type = $type;

    return $this;
  }

  public function getIsDismissible()
  {
    return $this->isDismissible;
  }

  public function setIsDismissible($isDismissible)
  {
    $this->isDismissible = $isDismissible;

    return $this;
  }

}
