<?php

namespace Bazookas\AdminBundle\Dashboard\Elements;

use Bazookas\AdminBundle\Dashboard\Base\BaseDashboardElement;
use Symfony\Component\OptionsResolver\OptionsResolver;

/**
 * @deprecated
 *
 * Class CalendarElement
 * @package Bazookas\AdminBundle\Dashboard\Elements
 */
class CalendarElement extends BaseDashboardElement {

  public $iconClass;

  public $data;

  public function __construct($children = [], $options = []) {
    parent::__construct($children, $options);

    $this->class = 'panel-' . $this->options['panelColor'] . ' ' . $this->options['class'];
    $this->iconClass = $this->options['icon'] . ' ' . $this->options['iconClass'];
    $this->data = $this->sortData($this->options['data']);
  }

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:Dashboard\Elements:calendarElement.html.twig',
      'class' => 'panel panel-colorful',
      'panelColor' => 'primary',
      'icon' => 'fa-user',
      'iconClass' => 'fa fa-4x mar-all',
      'data' => []
    ]);
  }

  /**
   * @param array $data an array of elements containing ['date'=> new \DateTime(), 'label' => '', 'colorClass' => '', 'link' => '']
   * @return array
   */
  private function sortData(array $data) {
    $dataResolver = new OptionsResolver();
    $dataResolver
      ->setDefaults([
        'date' => new \DateTime(),
        'label' => '',
        'colorClass' => 'success',
        'link' => ''
      ])
      ->setAllowedTypes('date', \DateTime::class)
    ;

    //Generate dates for each month
    $dates = $this->generateDates();

    foreach($data as $item) {
      //Check if the dates are valid
      $item = $dataResolver->resolve($item);
      $date = $item['date'];
      $dates[$date->format('F')][$date->format('Y-m-d')][] = $item;

      $item['date'] = $item['date']->format('Y-m-d');
    }

    return $dates;
  }

  private function generateDates() {
    $dates = array();
    $date = new \DateTime();
    $date->setDate($date->format('Y'), $date->format('m'), 1);

    for ($i = 0; $i < 12; $i++) {
      $numOfDays = $date->format('t');
      $monthName = $date->format('F');

      for($j = 0; $j < $numOfDays; $j++) {
        if (!isset($dates[$date->format('F')])) {
          $dates[$monthName] = [];
        }

        $dates[$monthName][$date->format('Y-m-d')] = [];

        $date->modify('+1 day');
      }
    }

    return $dates;
  }

}


