<?php

namespace Bazookas\AdminBundle\Repository\Interfaces;

use Bazookas\CommonBundle\Entity\Interfaces\EntityInterface;
use Doctrine\ORM\Query;
use Doctrine\ORM\QueryBuilder;

interface ListRepositoryInterface
{
  /**
   * @param array $fields
   * @param array $params
   * @return QueryBuilder
   */
  public function createListQueryBuilder(array $fields, array $params);

  /**
   * @param QueryBuilder $qb
   * @param array $params
   * @return QueryBuilder
   */
  public function beforeListQueryExecution(QueryBuilder $qb, array $params);

  /**
   * @param EntityInterface[] $entities
   */
  public function updateEntities(array $entities);

  /**
   * @param EntityInterface[] $entities
   */
  public function removeEntities(array $entities);

  /**
   * @param QueryBuilder $qb
   * @param int $page
   * @param int $limit
   * @param int $hydrationMode
   * @return array|EntityInterface[]
   */
  public function getPageableResult(QueryBuilder $qb, int $page, int $limit = 50, $hydrationMode = Query::HYDRATE_ARRAY);
}
