<?php

namespace Bazookas\APIFrameworkBundle\DependencyInjection\Compiler;

use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Symfony\Component\DependencyInjection\Reference;

/**
* see: http://symfony.com/doc/current/service_container/tags.html
* see: http://symfony.com/doc/current/components/dependency_injection/compilation.html#components-di-separate-compiler-passes
*/
class UserProviderPass implements CompilerPassInterface
{
    public function process(ContainerBuilder $container)
    {
        // always first check if the primary service is defined
        if (!$container->has('APIFrameworkBundle.UserProviders.UserProviderServiceChain')) {
            return;
        }

        $definition = $container->findDefinition('APIFrameworkBundle.UserProviders.UserProviderServiceChain');

        // find all service IDs with the app.mail_transport tag
        $taggedServices = $container->findTaggedServiceIds('APIFrameworkBundle.UserProviders');

        foreach ($taggedServices as $id => $tags) {
            // add the transport service to the ChainTransport service
            $definition->addMethodCall('addUserProvider', array(new Reference($id)));
        }
    }
}
