<?php

namespace Bazookas\APIFrameworkBundle\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * This is the class that validates and merges configuration from your app/config files.
 *
 * To learn more see {@link http://symfony.com/doc/current/cookbook/bundles/configuration.html}
 */
class Configuration implements ConfigurationInterface
{
  /**
   * {@inheritdoc}
   */
  public function getConfigTreeBuilder()
  {
    $treeBuilder = new TreeBuilder();
    $rootNode = $treeBuilder->root('bazookas_api_framework');

    $rootNode
      ->children()

        ->arrayNode('oAuth')
          ->children()
            ->booleanNode('facebookGrantTypeEnabled')
              ->defaultFalse()
            ->end()
            ->scalarNode('facebookGrantTypeUserProvider')
            ->end()
            ->booleanNode('allowRegistration')
              ->defaultFalse()
            ->end()
          ->end()
        ->end()

        ->arrayNode('file_upload')
          ->children()
            ->arrayNode('settings')
              ->children()
                ->scalarNode('root_directory')
                  ->defaultValue('%kernel.root_dir%/../web')
                ->end()
                ->scalarNode('uploads_root_directory')
                  ->defaultValue('%kernel.root_dir%/../web/uploads')
                ->end()
                ->scalarNode('baseUrl')
                  ->defaultNull()
                ->end()
                ->booleanNode('allow_application_octet_stream')
                  ->defaultFalse()
                ->end()
                ->scalarNode('uploadRoute')
                ->end()
              ->end()
            ->end()
          ->end()
        ->end()


        ->arrayNode('app_settings')
          ->children()
            ->scalarNode('entity')
              ->isRequired()
            ->end()
          ->end()
        ->end()

        ->arrayNode('app_copy')
          ->children()
            ->scalarNode('entity')
              ->isRequired()
            ->end()
            ->scalarNode('details_entity')
            ->end()
            ->scalarNode('allowed_locales')
            ->end()
          ->end()
        ->end()

      ->end()
    ;

    return $treeBuilder;
  }
}
