<?php

namespace Bazookas\APIFrameworkBundle\Exception;

use Bazookas\APIFrameworkBundle\Exception\Base\ApiExceptionMap;
use Bazookas\CommonBundle\Services\Exception\Interfaces\LoggableExceptionInterface;
use Exception;
use Symfony\Component\HttpFoundation\Response;

class InvalidTokenTypeException extends ApiException
{
  public function __construct($message, $name = ApiExceptionMap::INVALID_TOKEN_TYPE, $statusCode = Response::HTTP_FORBIDDEN, Exception $previous = null) {
    parent::__construct($message, $name, $statusCode, $previous);
  }

  /**
   * @inheritdoc
   */
  public function getLoggingSeverity() {
    return LoggableExceptionInterface::PRIORITY_INFO;
  }

}
