<?php

namespace Bazookas\APIFrameworkBundle\Form;

use Bazookas\AdminBundle\Form\Type\TranslationFormType;
use Bazookas\APIFrameworkBundle\Entity\Base\BaseAppCopy;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class AppCopyAdminType extends AbstractType
{
  /**
   * @param FormBuilderInterface $builder
   * @param array $options
   */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $data = $builder->getData();

    $builder
      ->add('key', null, [
        'label' => 'admin.entities.appCopy.fields.key',
        'disabled' => !is_null($data->getKey()),
      ])
      ->add('details', TranslationFormType::class, [
        'label' => 'admin.entities.appCopy.fields.details',
        'entry_type' => AppCopyDetailAdminType::class,
      ])
    ;
  }

  /**
   * @param OptionsResolver $resolver
   */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults([
      'data_class' => BaseAppCopy::class
    ]);
  }
}
