<?php
/**
 * Created by PhpStorm.
 * User: robbeclerckx
 * Date: 28/10/16
 * Time: 16:22
 */

namespace Bazookas\APIFrameworkBundle\Util;


use Symfony\Component\HttpFoundation\ParameterBag;

class APIFileUploadCallback
{
  private $service;
  private $method;
  private $parameters;

  public function __construct($service, $method, $parameters) {
    $this->service = $service;
    $this->method = $method;
    $this->parameters = $parameters;
  }

  /**
   * @return mixed
   */
  public function getService()
  {
    return $this->service;
  }

  /**
   * @param mixed $service
   * @return APIFileUploadCallback
   */
  public function setService(string $service)
  {
    $this->service = $service;
    return $this;
  }

  /**
   * @return mixed
   */
  public function getMethod()
  {
    return $this->method;
  }

  /**
   * @param mixed $method
   * @return APIFileUploadCallback
   */
  public function setMethod(string $method)
  {
    $this->method = $method;
    return $this;
  }

  /**
   * @return mixed
   */
  public function getParameters()
  {
    return $this->parameters;
  }

  /**
   * @param mixed $parameters
   * @return APIFileUploadCallback
   */
  public function setParameters(ParameterBag $parameters)
  {
    $this->parameters = $parameters;
    return $this;
  }

  /**
   * returns parameterbag
   * @return null|ParameterBag
   */
  public function getParameterBag() {
    if (is_array($this->parameters)) {
      return new ParameterBag($this->parameters);
    }
    return new ParameterBag();
  }


}
