<?php

namespace Bazookas\CommonBundle\Tests\Bazookas\CommonBundle\Entity;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\ORM\PersistentCollection;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity
 * @ORM\HasLifecycleCallbacks
 */
class NestedTestEntity extends BaseEntity {

  /**
   * @var string
   */
  private $name;

  /**
   * @var array
   */
  private $arrayItems;

  /**
   * @var ArrayCollection
   */
  private $arrayCollectionItems;

  /**
   * @return string
   */
  public function getName()
  {
    return $this->name;
  }

  /**
   * @param string $name
   * @return $this
   */
  public function setName(string $name)
  {
    $this->name = $name;

    return $this;
  }

  /**
   * @return array
   */
  public function getArrayItems()
  {
    return $this->arrayItems;
  }

  /**
   * @param array $arrayItems
   * @return $this
   */
  public function setArrayItems(array $arrayItems)
  {
    $this->arrayItems = $arrayItems;

    return $this;
  }

  /**
   * @return ArrayCollection
   */
  public function getArrayCollectionItems()
  {
    return $this->arrayCollectionItems;
  }

  /**
   * @param ArrayCollection $arrayCollectionItems
   * @return $this
   */
  public function setArrayCollectionItems(ArrayCollection $arrayCollectionItems)
  {
    $this->arrayCollectionItems = $arrayCollectionItems;

    return $this;
  }

}
