<?php

namespace Bazookas\CronBundle\Command;

use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

class ClearCronsHistoryCommand extends ContainerAwareCommand
{
  /**
  * {@inheritdoc}
  */
  protected function configure()
  {
    $this
      ->setName('crons:history:clear')
      ->addOption('before', null, InputOption::VALUE_REQUIRED, 'Clear history before the set amount of time')
    ;
  }

  /**
  * {@inheritdoc}
  */
  protected function execute(InputInterface $input, OutputInterface $output)
  {
    $em = $this->getContainer()->get('doctrine')->getManager();

    $date = new \DateTime('-'.$input->getOption('before'), new \DateTimeZone('UTC'));
    $query = $em->createQuery(
      'DELETE BazookasCronBundle:CronHistory h WHERE h.runEnd < :date'
    )->setParameter('date', $date);

    $query->execute();

  }
}
