<?php
namespace Bazookas\CronBundle\DataFixtures\ORM;

use Doctrine\Common\DataFixtures\FixtureInterface;
use Doctrine\Common\Persistence\ObjectManager;
use Bazookas\CronBundle\Entity\Cron;

class CronFixtures implements FixtureInterface
{
  public function load(ObjectManager $manager)
  {
    $this->create($manager, 'bin/console crons:history:clear --before="14 days"', '14', 'days', Cron::STATUS_SCHEDULED);
    $this->create($manager, 'bin/console fos:oauth:clean', '5', 'days', Cron::STATUS_INACTIVE);

    $manager->flush();
  }

  private function create(ObjectManager $manager, $command, $interval, $intervalUnit, $status) {
    $cronJob = new Cron();
    $dateLast = date_create();
    $dateNext = date_add(date_create(), date_interval_create_from_date_string($interval.' '.$intervalUnit));
    $cronJob
      ->setCommand($command)
      ->setExecutionInterval($interval)
      ->setIntervalUnit($intervalUnit)
      ->setNextRunOn($dateNext)
      ->setStatus($status)
      ->setLastRunOn($dateLast)
      ->setLastRunStatus(Cron::STATUS_SUCCESS)
      ->setMaxExecutionTime(30)
      ->setMaxExecutionsBeforeFail(3)
      ->setFailureCount(0)
    ;

    // persist the sucker
    $manager->persist($cronJob);

    return $cronJob;
  }
}
