<?php

namespace Bazookas\CronBundle\Form;

use Bazookas\CronBundle\BazookasCronBundle;
use Bazookas\CronBundle\Entity\Cron;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class CronAdminType extends AbstractType
{
  /**
   * @param FormBuilderInterface $builder
   * @param array $options
   */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    // TODO configure form fields
    $builder
        // string input
      ->add('command', TextType::Class, array('label' => 'admin.entities.cron.fields.command'))
        // int input
      ->add('executionInterval', IntegerType::Class, array('label' => 'admin.entities.cron.fields.executionInterval'))
      ->add('intervalUnit', ChoiceType::Class, array(
        'choices' => array(
          Cron::INTERVAL_SECONDS,
          Cron::INTERVAL_MINUTES,
          Cron::INTERVAL_HOURS,
          Cron::INTERVAL_DAYS
        ),
        'label' => 'admin.entities.cron.fields.intervalUnit',
        'choice_label' => function ($value) {
          return 'admin.entities.cron.enums.interval.'.$value;
        }
      ))
        // int input
      ->add('maxExecutionTime', IntegerType::Class, array(
        'label' => 'admin.entities.cron.fields.maxExecutionTime',
        'attr' => [
          'min' => 0,
        ]
      ))
      // int input
      ->add('maxExecutionsBeforeFail', IntegerType::Class, array('label' => 'admin.entities.cron.fields.maxExecutionsBeforeFail'))
      ->add('continueAfterFailCount', null, array('label' => 'admin.entities.cron.fields.continueAfterFailCount'))
    ;
  }

  /**
   * @param OptionsResolver $resolver
   */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults(array(
      'data_class' => 'Bazookas\CronBundle\Entity\Cron'
    ));
  }
}
