<?php
namespace Bazookas\MediaBundle\Exception\Base;

use Bazookas\CommonBundle\Exception\Base\BaseException;
use Bazookas\CommonBundle\Exception\Base\BaseExceptionMap;
use Exception;
use Bazookas\MediaBundle\Exception\Interfaces\MediaExceptionInterface;
use Bazookas\AdminBundle\Exception\Interfaces\AdminExceptionInterface;

abstract class BaseMediaException extends BaseException  implements MediaExceptionInterface, AdminExceptionInterface {
  protected $payload;

  // Redefine the exception so message isn't optional
  public function __construct($message, $name = BaseExceptionMap::GENERAL_ERROR, Exception $previous = null, $payload = null) {
    $this->payload = $payload;

    // make sure everything is assigned properly
    parent::__construct($message, 0, $previous);
  }

  public function getPayload() {
    return $this->payload;
  }

}
