### Installing with composer

Add the following to composer.json (composer will ask authentication for private bundles the first time you install a bazookas bundle)
```json
    "repositories": [
        {
            "type": "vcs",
            "url": "https://github.com/Bazookastudios/BazookasMediaBundle.git"
        }
    ],
```

And then: `composer require bazookas/media-bundle`


### As a git submodule
Use this command in the root of your repository to add this bundle as a submodule.

```bash
git submodule add -b master --name MediaBundle https://github.com/Bazookastudios/BazookasMediaBundle.git ./src/Bazookas/MediaBundle
```

### Import in app/config.yml

```
    - { resource: "@BazookasMediaBundle/Resources/config/menu.yml" }
```

### Optional configuration in app/config.yml

```yml
bazookas_media:
  # when using api file uploader
  file_upload:
    settings:
      # these are the default values
      root_directory: '%kernel.root_dir%/../web'
      uploads_root_directory: '%kernel.root_dir%/../web/uploads'
      # when no base url is provided (or null) it will default to the router context
      # dynamically getting base url from request
      baseUrl: ~
    default_folders:
        appUsers: APP_USER
        teams: TEAM
```

### Activate in AppKernel.php

```php
      new Bazookas\MediaBundle\BazookasMediaBundle(),
```
